/*

@C:\web_550\sql\end_conv\sqlserver\1060_FINSTPS_UTIL_VENCIMENTOS.SQL;

DEBUGAR PROCEDURE
RAISERROR('', 16,1);

*/

IF EXISTS (SELECT *
           FROM SYSOBJECTS O, SYSUSERS U
           WHERE O.NAME = 'DIAMES' AND
                 TYPE   = 'P' 	   AND
                 U.UID  = O.UID    AND
                 U.NAME = USER)
DROP PROCEDURE DIAMES
GO

IF EXISTS (SELECT *
             FROM SYSOBJECTS O, SYSUSERS U
            WHERE O.NAME = 'DIAMES' AND
                  TYPE   = 'FN'     AND
                  U.UID  = O.UID    AND
                  U.NAME = USER)
DROP FUNCTION DIAMES
GO


CREATE FUNCTION DIAMES
(
   @P_CDFORMPGTO   VARCHAR(02),
   @P_DTVENCIMENTO DATETIME)
   RETURNS DATETIME

AS
BEGIN
   DECLARE @V_DTVENCIMENTO  DATETIME;

   DECLARE @V_BASEDIA         VARCHAR(02);
   DECLARE @V_NRDIAPGTOVAR    VARCHAR(02);
   DECLARE @V_NRDIAPGTOSEMANA VARCHAR(02);

   DECLARE @V_NRMESFORMPGT    NUMERIC;
   DECLARE @V_NRNUMMESPGTO    NUMERIC;

   DECLARE @V_INVERICAMES     NUMERIC;
   DECLARE @V_INDIAS          NUMERIC;

   SET @V_DTVENCIMENTO = @P_DTVENCIMENTO;
   SET @V_BASEDIA = RIGHT(REPLICATE('0', 2) + CONVERT(VARCHAR,DATEPART(D, @V_DTVENCIMENTO)), 2);

   SELECT @V_NRDIAPGTOVAR = NRDIAPGTOVAR, @V_NRMESFORMPGT = NRMESFORMPGT, @V_NRNUMMESPGTO = ISNULL(NRNUMMESPGTO, 1), @V_NRDIAPGTOSEMANA = ISNULL(NRDIAPGTOSEMANA, '00')
     FROM DIAPGTO
    WHERE CDFORMPGTO   = @P_CDFORMPGTO
      AND NRDIAINIPGTO <= @V_BASEDIA
      AND NRDIAFINPGTO >= @V_BASEDIA;

   IF @V_NRMESFORMPGT = 0 BEGIN
      SET @V_INVERICAMES = 0;
   END
   ELSE BEGIN
      SET @V_INVERICAMES = @V_NRNUMMESPGTO;
   END;

   IF NOT @V_NRDIAPGTOVAR IS NULL BEGIN

      SET @V_DTVENCIMENTO = DATEADD(MM, @V_INVERICAMES, @V_DTVENCIMENTO);

      SET @V_INDIAS = CONVERT(INT, DAY(DATEADD(MM,1,@V_DTVENCIMENTO)-DAY(@V_DTVENCIMENTO)));

      IF @V_NRDIAPGTOVAR > @V_INDIAS BEGIN
         SET @V_DTVENCIMENTO = DATEADD(MM,1,@V_DTVENCIMENTO)-DAY(@V_DTVENCIMENTO);
      END
      ELSE BEGIN
         /*Joga a data com o dia informado na parametrizao */
         SET @V_DTVENCIMENTO = CONVERT(DATETIME, CONVERT(VARCHAR,@V_NRDIAPGTOVAR)+'/'+CONVERT(VARCHAR, MONTH(@V_DTVENCIMENTO))+'/'+CONVERT(VARCHAR, YEAR(@V_DTVENCIMENTO)), 103);
      END;

      IF @V_NRDIAPGTOSEMANA <> '00' BEGIN
         IF RIGHT(REPLICATE('0', 2) + CONVERT(VARCHAR,DATEPART(W, @V_DTVENCIMENTO)), 2) <> @V_NRDIAPGTOSEMANA BEGIN
            WHILE RIGHT(REPLICATE('0', 2) + CONVERT(VARCHAR,DATEPART(W, @V_DTVENCIMENTO)), 2) <> @V_NRDIAPGTOSEMANA  BEGIN
               SET @V_DTVENCIMENTO = @V_DTVENCIMENTO + 1;
            END;
         END;
      END;
   END;

   RETURN(@V_DTVENCIMENTO);
END
GO


IF EXISTS (SELECT *
           FROM SYSOBJECTS O, SYSUSERS U
           WHERE O.NAME = 'DIASEMANA' AND
                 TYPE   = 'P' 	      AND
                 U.UID  = O.UID       AND
                 U.NAME = USER)
DROP PROCEDURE DIASEMANA
GO

IF EXISTS (SELECT *
           FROM SYSOBJECTS O, SYSUSERS U
           WHERE O.NAME = 'DIASEMANA' AND
                 TYPE   = 'FN' 	      AND
                 U.UID  = O.UID       AND
                 U.NAME = USER)
DROP FUNCTION DIASEMANA
GO

CREATE FUNCTION DIASEMANA
(
   @P_CDFORMPGTO   VARCHAR(02),
   @P_DTVENCIMENTO DATETIME)
   RETURNS DATETIME

AS
BEGIN

   DECLARE @V_BASEDIA       VARCHAR(02);
   DECLARE @V_DTVENCIMENTO  DATETIME;

   DECLARE @V_NRDIAPGTOVAR    VARCHAR(02);
   DECLARE @V_NRMESFORMPGT    NUMERIC;
   DECLARE @V_NRNUMMESPGTO    NUMERIC;
   DECLARE @V_NRDIAINIPGTO    NUMERIC;
   DECLARE @V_NRDIAFINPGTO    NUMERIC;
   DECLARE @V_NRDIAINIPGTOAUX NUMERIC;
   DECLARE @V_NRDIAFINPGTOAUX NUMERIC;
   DECLARE @V_NRDIAPGTOVARAUX NUMERIC;
   DECLARE @V_NRMESFORMPGTAUX NUMERIC;

   SET @V_DTVENCIMENTO = @P_DTVENCIMENTO;

   SET @V_BASEDIA = RIGHT(REPLICATE('0', 2) + DATEPART(W, @V_DTVENCIMENTO), 2);

   SELECT @V_NRDIAINIPGTOAUX = NRDIAINIPGTO, @V_NRDIAFINPGTOAUX = NRDIAFINPGTO, @V_NRDIAPGTOVARAUX = NRDIAPGTOVAR, @V_NRMESFORMPGTAUX = NRMESFORMPGT
     FROM DIAPGTO
    WHERE CDFORMPGTO = @P_CDFORMPGTO;

   IF @V_NRDIAINIPGTOAUX <= @V_NRDIAFINPGTOAUX BEGIN

      SELECT @V_NRDIAPGTOVAR = NRDIAPGTOVAR, @V_NRMESFORMPGT = NRMESFORMPGT, @V_NRNUMMESPGTO = ISNULL(NRNUMMESPGTO, 1)
        FROM DIAPGTO
       WHERE CDFORMPGTO    = @P_CDFORMPGTO
         AND NRDIAINIPGTO <= @V_BASEDIA
         AND NRDIAFINPGTO >= @V_BASEDIA;

      IF NOT @V_NRDIAPGTOVAR IS NULL BEGIN /*Se h dia para pagamento cadastrado */
         IF @V_NRMESFORMPGT = 0 BEGIN  /*Semana para pagamento Atual*/
            IF RIGHT(REPLICATE('0', 2) + DATEPART(W, @V_DTVENCIMENTO), 2) = @V_NRDIAPGTOVAR BEGIN /*Se dia para pagamento j esta correto*/
               SET @V_DTVENCIMENTO = @V_DTVENCIMENTO;
            END
            ELSE BEGIN
               WHILE RIGHT(REPLICATE('0', 2) + DATEPART(W, @V_DTVENCIMENTO), 2) <> @V_NRDIAPGTOVAR  BEGIN
                  SET @V_DTVENCIMENTO = @V_DTVENCIMENTO + 1;
               END;
            END;
         END
         ELSE BEGIN /*Semana para pagamento Seguinte*/
            IF RIGHT(REPLICATE('0', 2) + DATEPART(W, @V_DTVENCIMENTO), 2) = @V_NRDIAPGTOVAR BEGIN /*Se dia para pagamento j esta correto*/
               SET @V_DTVENCIMENTO = @V_DTVENCIMENTO + 7;
            END
            ELSE BEGIN
               IF RIGHT(REPLICATE('0', 2) + DATEPART(W, @V_DTVENCIMENTO), 2) < @V_NRDIAPGTOVAR BEGIN
                  SET @V_DTVENCIMENTO = @V_DTVENCIMENTO + 7;
               END;

               WHILE RIGHT(REPLICATE('0', 2) + DATEPART(W, @V_DTVENCIMENTO), 2) <> @V_NRDIAPGTOVAR BEGIN
                  SET @V_DTVENCIMENTO = @V_DTVENCIMENTO + 1;
               END;
            END;
         END;
      END;
   ELSE
      IF NOT @V_NRDIAPGTOVARAUX IS NULL BEGIN /*Se h dia para pagamento cadastrado */
         IF @V_NRMESFORMPGTAUX = 0 BEGIN  /*Semana para pagamento Atual*/
            IF RIGHT(REPLICATE('0', 2) + DATEPART(W, @V_DTVENCIMENTO), 2) = @V_NRDIAPGTOVARAUX BEGIN /*Se dia para pagamento j esta correto*/
               SET @V_DTVENCIMENTO = @V_DTVENCIMENTO;
            END
            ELSE BEGIN
               WHILE RIGHT(REPLICATE('0', 2) + DATEPART(W, @V_DTVENCIMENTO), 2) <> @V_NRDIAPGTOVARAUX  BEGIN
                  SET @V_DTVENCIMENTO = @V_DTVENCIMENTO + 1;
               END;
            END;
         END
         ELSE BEGIN /*Semana para pagamento Seguinte*/
            IF RIGHT(REPLICATE('0', 2) + DATEPART(W, @V_DTVENCIMENTO), 2) = @V_NRDIAPGTOVARAUX BEGIN /*Se dia para pagamento j esta correto*/
               SET @V_DTVENCIMENTO = @V_DTVENCIMENTO + 7;
            END
            ELSE BEGIN
               IF RIGHT(REPLICATE('0', 2) + DATEPART(W, @V_DTVENCIMENTO), 2) < @V_NRDIAPGTOVARAUX BEGIN
                  SET @V_DTVENCIMENTO = @V_DTVENCIMENTO + 7;
               END;

               WHILE RIGHT(REPLICATE('0', 2) + DATEPART(W, @V_DTVENCIMENTO), 2) <> @V_NRDIAPGTOVARAUX BEGIN
                  SET @V_DTVENCIMENTO = @V_DTVENCIMENTO + 1;
               END;
            END;
         END;
      END;
   END;

   RETURN(@V_DTVENCIMENTO);
END
GO


IF EXISTS (SELECT *
           FROM SYSOBJECTS O, SYSUSERS U
           WHERE O.NAME = 'DIASEMANAMES' AND
                 TYPE   = 'P' 	         AND
                 U.UID  = O.UID          AND
                 U.NAME = USER)
DROP PROCEDURE DIASEMANAMES
GO

IF EXISTS (SELECT *
           FROM SYSOBJECTS O, SYSUSERS U
           WHERE O.NAME = 'DIASEMANAMES' AND
                 TYPE   = 'FN' 	         AND
                 U.UID  = O.UID          AND
                 U.NAME = USER)
DROP FUNCTION DIASEMANAMES
GO

CREATE FUNCTION DIASEMANAMES
(
   @P_CDFORMPGTO   VARCHAR(02),
   @P_DTVENCIMENTO DATETIME)
   RETURNS DATETIME

AS
BEGIN
   DECLARE @V_BASEDIA       VARCHAR(02);
   DECLARE @V_DTVENCIMENTO  DATETIME;

   DECLARE @V_NRDIAPGTOVAR  VARCHAR(02);
   DECLARE @V_NRMESFORMPGT  NUMERIC;
   DECLARE @V_NRNUMMESPGTO  NUMERIC;

   SET @V_DTVENCIMENTO = @P_DTVENCIMENTO;

   SET @V_BASEDIA = DAY(@V_DTVENCIMENTO);

   SELECT @V_NRDIAPGTOVAR = NRDIAPGTOVAR, @V_NRMESFORMPGT = NRMESFORMPGT, @V_NRNUMMESPGTO = ISNULL(NRNUMMESPGTO, 1)
     FROM DIAPGTO
    WHERE CDFORMPGTO    = @P_CDFORMPGTO
      AND NRDIAINIPGTO <= @V_BASEDIA
      AND NRDIAFINPGTO >= @V_BASEDIA;

   IF NOT @V_NRDIAPGTOVAR IS NULL BEGIN
      SET @V_DTVENCIMENTO = CONVERT(DATETIME, CONVERT(VARCHAR, '01/')+CONVERT(VARCHAR, MONTH(@V_DTVENCIMENTO))+'/'+CONVERT(VARCHAR,YEAR(@V_DTVENCIMENTO)), 103);

      IF NOT @V_NRMESFORMPGT = 0 BEGIN
         SET @V_DTVENCIMENTO = DATEADD(MM, @V_NRMESFORMPGT, @V_DTVENCIMENTO);
      END;

      IF @V_NRNUMMESPGTO = 2 BEGIN
         SET @V_DTVENCIMENTO = @V_DTVENCIMENTO + 7;
      END;

      IF @V_NRNUMMESPGTO = 3 BEGIN
         SET @V_DTVENCIMENTO = @V_DTVENCIMENTO + 14;
      END;

      IF @V_NRNUMMESPGTO = 4 BEGIN
         SET @V_DTVENCIMENTO = @V_DTVENCIMENTO + 21;
      END;

      IF RIGHT(REPLICATE('0', 2) + DATEPART(W, @V_DTVENCIMENTO), 2) <> @V_NRDIAPGTOVAR BEGIN
         WHILE RIGHT(REPLICATE('0', 2) + DATEPART(W, @V_DTVENCIMENTO), 2) <> @V_NRDIAPGTOVAR BEGIN
            SET @V_DTVENCIMENTO = @V_DTVENCIMENTO + 1;
         END;
      END;
   END;

   RETURN(@V_DTVENCIMENTO);
END
GO

-- VERSAO --
EXEC ATUVEROBJ 'UTIL_CRIAVENCIMENTO','5.50.xxx';
GO
